 { Unit:            magtool2.pas
  Autor:           Sascha Nemecek
  Matrikelnr.:     9825815
  Erstellt am:     10.04.1999
  Letzte nderung: 01.06.1999

  Kurzbeschreibung:
  }


UNIT MagTool2;


INTERFACE


USES CRT;

TYPE
   string13 = string[13];


FUNCTION isAlpha (c: char): boolean;
FUNCTION isNum (c: char): boolean;
FUNCTION jn_abfrage (s: string) : boolean;
FUNCTION ReadDateiName (var name: string13) : boolean;
FUNCTION readinteger : integer;
PROCEDURE readstrn (var s: string; n: integer);
FUNCTION ricky : char;
PROCEDURE strincpy (VAR d: STRING; s: STRING; i, n: integer);
FUNCTION strisAlphaNum (s: STRING) : boolean;
PROCEDURE strtoupper (VAR s: STRING);
PROCEDURE wait;
PROCEDURE textWindow (xpos, ypos, w, h: integer);


IMPLEMENTATION



{ Funktion isAlpha.
  berprft ob der bergebene Char ein Buchstabe ist.
  @param  Das zu untersuchende Zeichen.
  @return TRUE  Wenn Buchstabe.
          FALSE Wenn keiner. }
FUNCTION isAlpha (c: char): boolean;
BEGIN
   c := upCase (c);
   IF (c<='Z') AND (c>='A') THEN
      isAlpha := TRUE
   ELSE
      isAlpha := FALSE;
END;




{ Funktion isNum.
  berprft ob der bergebene Char eine Zahl ist.
  @param  Das zu untersuchende Zeichen.
  @return TRUE  Wenn Zahl.
          FALSE Wenn keine. }
FUNCTION isNum (c: char): boolean;
BEGIN
   IF (c<='9') AND (c>='0') THEN
      isNum := TRUE
   ELSE
      isNum := FALSE;
END;




{ Funktion JN_Abfrage.
  Einfache Ja/Nein Abfrage.
  @param  s     der Fragetext.
  @return TRUE  bei Ja.
          FALSE bei Nein. }
FUNCTION jn_abfrage (s: string) : boolean;

VAR
   jn : char;
   i  : integer;

BEGIN
   i := length (s);
   textWindow (80 div 2 - i div 2 - 2, 17, i + 6, 3);

   gotoxy(80 div 2 - i div 2 +1, 18);write(s);
   jn:='R';
   REPEAT
      jn := ricky;
      jn := upcase(jn);
   UNTIL (jn='N') OR (jn='J');

   IF jn = 'N' THEN
      jn_abfrage := FALSE
   ELSE
      jn_abfrage := TRUE;
END;




{ Function ReadDateiName ().
  Liet einen Dateinamen von der Tastatur ein.
  @param name Der String der zurckgegeben wird.
  @return TRUE, wenn die Eingabe erfolgreich (gltig) war. }
FUNCTION ReadDateiName (VAR name: string13) : boolean;

VAR xpos, ypos, count, ext: integer;
    taste: char;

BEGIN
   count := 0;
   ext := 0;
   taste := #0;

   FOR xpos:=0 TO 12 DO
      name [xpos] := #0;

   xpos := wherex;
   ypos := wherey;
   write ('             ');
   gotoxy(xpos, ypos);

   WHILE (taste <> #13) AND (taste <> #27) DO BEGIN
      taste := #0;
      REPEAT
         taste := ricky;
      UNTIL isAlpha (taste) OR isNum (taste) OR (taste = '.') OR
            (taste = #8) OR (taste = #13) OR (taste = #27) OR (taste='-');

      { Falls extension. }
      IF ((taste='.') AND (ext=0) AND (count>0)) THEN BEGIN
         name := name + upcase (taste);
	 inc (ext);
         taste := #0;
      END;

      IF (isNum (taste) OR isAlpha (taste) OR (taste = '-')) AND
         (((count<8) AND (ext=0)) OR
         ((count<=8) AND (ext<4) AND (ext>0))) THEN BEGIN

	 name := name + upcase(taste);
	 IF (ext>0) THEN
	 inc (ext)
      ELSE
         inc (count);
         taste := #0;
      END;

      IF ((taste=#8) AND (count>0)) THEN BEGIN
         IF(ext>0) THEN
	    dec (ext)
	 ELSE
	    dec (count);
	 name[0] := chr (count+ext);
         taste := #0;
      END;

      gotoxy(xpos, ypos);
      write ('             ');
      gotoxy(xpos, ypos);
      write (name);
      gotoxy(xpos+count+ext, ypos);
   END;

   WHILE (name [count+ext-1]=#32) DO
      name[count+ext-1] := #0;

   IF ((count+ext) > 0) AND (taste <> #27) THEN
      ReadDateiName := true
   ELSE
      ReadDateiName := false;
END;




{ Prozedur readinteger ().
  Liet einen Integerwert ein.
  @return Der Wert der eingelesen wurde. }
FUNCTION readinteger : integer;

VAR
   ein     : char;
   ch      : byte;
   eingabe : word;

BEGIN
   eingabe := 0;
   ch := 0;

   REPEAT
      { Einlesen eines gltigen Zeichens }
      REPEAT{$I-}
         ein := readkey;{$I+}
      UNTIL (ein = #13) OR (ein = #8) OR ((isNum (ein)) AND (eingabe < 3276));

      { Wenn nicht <ENTER> auswerten. }
      IF (ein<>#13) THEN

         { Bei Zahl. }
         IF (ein <> #8) THEN BEGIN
            eingabe := eingabe*10 + (ord (ein)-48);

            IF eingabe < 0 THEN
               eingabe := (eingabe - (ord (ein)-48)) div 10
            ELSE BEGIN
               write (ein);
               inc (ch);
            END;

         { Bei Backspace. }
         END ELSE IF ch > 0 THEN BEGIN
            write (#8,' ',#8);
            dec (ch);
            eingabe := trunc (eingabe/10);
         END;

   UNTIL ein = chr(13);

   readinteger := eingabe;
END;




{ Prozedur readstrn.
  Liet einen String mit max. n Zeichen ein.
  @param s der String der eingelesen wird.
  @param n die Anzahl der max. Zeichen. }
PROCEDURE readstrn (var s: string; n: integer);

VAR ein: char;
    ch : byte;

BEGIN
   s[0] := #0;
   ch := 0;

   REPEAT
      { Einlesen eines gltigen Zeichens }
      REPEAT{$I-}
         ein := readkey;{$I+}
      UNTIL (isAlpha (ein)) OR (isNum (ein)) OR (ein = chr(13)) OR (ein =chr(8));

      IF (ein<>#13) THEN

         { Bei normaler Eingabe. }
         IF (ein<>#8) THEN BEGIN
            IF (ch < n) THEN BEGIN
               write (ein);
               inc(ch);
               s := s + ein;
            END;

         { Wenn Backspace gedrckt wurde. }
         END ELSE IF ch > 0 THEN BEGIN
            write (#8,' ',#8);
            dec(ch);
            s[0] := chr (ch);
         END;

   UNTIL ein = chr(13);
END;





{ Funktion ricky ().
  Leit bei Tastendruck ein Zeichen ein.
  @return jn Das gelesene Zeichen. }
FUNCTION ricky : char;
BEGIN
   IF keypressed THEN ricky := readkey
   ELSE ricky := #0;
END;




{ Prozedur strincpy.
  Kopiert von einen String n Zeichen ab dem i-ten Zeichen
  in einen anderen.
  @param d Der Zielstring.
  @param s Der Quellstring.
  @param i Position ab der kopiert werden soll.
  @param n Anzahl der Zeichen, die kopiert werden sollen. }
PROCEDURE strincpy (VAR d: STRING; s: STRING; i, n: integer);
VAR c: integer;
BEGIN
   d[0] := #0;

   FOR c := i TO (i+n-1) DO
      d := d + s[c];
END;




{ Funktion strisAlphaNum.
  berprft, ob der bergebene String alphanumerisch ist.
  @param  s Der zu untersuchende String.
  @return TRUE  wenn er alphanumerisch ist.
          FALSE wenn er nicht alphanumerisch ist. }
FUNCTION strisAlphaNum (s: STRING) : boolean;

VAR
   i : integer;
   w : boolean;

BEGIN
   w := TRUE;
   FOR i := 1 TO length (s) DO
      IF (isAlpha (s[i]) = FALSE) AND (isNum (s[i]) = FALSE) THEN
         w := FALSE;

   strisAlphaNum := w;
END;




{ Prozedur strtoupper.
  Wandelt einen String in Grossbuchstaben um.
  @param s Der umzuwandelnde String. }
PROCEDURE strtoupper (VAR s: STRING);
VAR i: INTEGER;
BEGIN
   FOR i := 1 to length (s) DO
      s[i] := upcase (s[i]);
END;




{ Prozedur wait.
  Wartet solange, bis [ENTER] gedrckt wird. }
PROCEDURE wait;
VAR jn:char;
BEGIN
   { Text ausgeben. }
   gotoxy(35,25);
   write('Press Enter');
   jn:='1';

   { Auf <ENTER> warten. }
   REPEAT
      jn := ricky;
   UNTIL jn = chr(13);

   { Text wieder lschen. }
   gotoxy(35,25);
   write('           ');
END;




{ Prozedur textWindow.
  Zeichnet ein Fenster an der angegebenen Position in der ang. Grsse.
  @param xpos Die X Position.
  @param ypos Die Y Position.
  @param w    Die Breite des Fensters (mindestens 3).
  @param h    Die Hhe des Fensters (mindestens 3). }
PROCEDURE textWindow (xpos, ypos, w, h: integer);

VAR
   i : integer;

BEGIN
   IF (w < 3) OR (h < 3) THEN
      exit;

   { Erste Zeile. }
   gotoxy (xpos, ypos); write ('');
   FOR i := 2 TO w DO write ('');
   write ('');

   { Mittelteil. }
   FOR i := 2 TO h DO BEGIN
      gotoxy (xpos, ypos + i - 1);
      write ('');
      gotoxy (xpos + w, ypos + i - 1);
      write ('');
   END;

   { Letzte Zeile. }
   gotoxy (xpos, ypos+h-1); write ('');
   FOR i := 2 TO w DO
      write ('');
   write ('');
END;




BEGIN
END.