{ Programm:        schedule.pas
  Autor:           Sascha Nemecek
  Matrikelnr.:     9825815
  Erstellt am:     01.06.1999
  Letzte nderung: 04.06.1999

  Kurzbeschreibung:
  }


PROGRAM schedule;

{ Eingebundene Units. }
USES ADJ_LIST, CRT, MAGTOOL2, LINLIST2, TOKEN;


CONST
   ABFRAGE01 = 'Soll dieser Arbeitsvorgang wirklich geloescht werden [J/N]?';
   ABFRAGE02 = 'Datei existiert bereits!  berschreiben [J/N]?';
   ABFRAGE03 = 'Der aktuelle Graph wird gelscht! Fortfahren [J/N]?';

   ERR01     = 'Fehler: Es sind keine Arbeitsvorgnge vorhanden!!';
   ERR02     = 'Fehler: Ein Arbeitsvorgang mit dieser Kurzbezeichnung existiert nicht!!';
   ERR03     = 'Fehlerhafte Eingabe - ABBRUCH!';

   HEADER01  = 'Kurzbezeichnung |                 Name | min. / max. Dauer';

   TITLE01   = 'Auflistung der Arbeitsvorgnge';
   TITLE02   = 'Linearisierten Arbeitsvorgnge';
   TITLE03   = 'Kritischer Pfad';
   TITLE04   = 'Auflistung der Startknoten';
   TITLE05   = 'Auflistung der Zielknoten';



TYPE

{ Klasse Scheduler. }
schedPtr = ^Scheduler;
Scheduler = OBJECT
   PRIVATE
      data : AdjPtr;

      PROCEDURE Graph_Laden;
      PROCEDURE Graph_Linearisieren;
      PROCEDURE Graph_Speichern;

      PROCEDURE Kante_Ausgeben;
      PROCEDURE Kante_Loeschen;
      PROCEDURE Kante_Neu;

      PROCEDURE Knoten_Ausgeben (s: string; l: ListePtr; min, max: integer);
      PROCEDURE Knoten_Loeschen;
      PROCEDURE Knoten_Neu;

      PROCEDURE Menu_Abhaengigkeiten;
      PROCEDURE Menu_Arbeitsvorgaenge;
      PROCEDURE Menu_Main;

   {PUBLIC}
      CONSTRUCTOR init;
      DESTRUCTOR done;
END;


{ Globale Variable. }
VAR
   sched : schedPtr;




CONSTRUCTOR Scheduler.init;

VAR
   px, py: byte;
   f: file;
   schirm: integer absolute$B800:$0000;

BEGIN
   {Adjazenzliste initialisieren.}
   data := new (AdjPtr, Init);

   {Abfrage der X-/Y-Koordinaten des Cursors}
   px:=wherex;py:=wherey;

   {Speichern des vorhandnen DOS-Bildschirms}
   assign(f,'SCHIRM');
   rewrite(f);
   blockwrite(f,schirm,32);
   close(f);
   {Ende der Speicherung des DOS-Bildschirms}

   {Men aufrufen }
   Menu_Main;

   {Wiederaufbau des DOS-Bildschirms}
   textcolor(white);textbackground(0);
   clrscr;
   reset(f);
   blockread(f,schirm,32);
   erase(f);
   {Ende des DOS-Bildschirm wiederaufbaus}

   {Rcksetzen des Cursors}
   gotoxy(px,py);
END;




DESTRUCTOR Scheduler.done;
BEGIN
   dispose (data, done);
END;




{ Prozedure Graph_Laden.
  Ld einen Graph aus einem angegebenen File. }
PROCEDURE Scheduler.Graph_Laden;

VAR
   eindat      : text;
   dateiname   : string13;
   s, tok, abh : string;
   bez         : string4;
   name        : string20;
   min, max, c : integer;
   error, ok   : boolean;

BEGIN
   clrscr;

   { berprfung ob ein Graph geladen ist }
   IF NOT data^.isEmpty THEN
      IF NOT jn_abfrage (ABFRAGE03) THEN
         exit
      ELSE
         dispose (data, done);

   { Dateieingabemaske. }
   clrscr;
   gotoxy(2,8); write('ͻ');
   gotoxy(2,9); write('                                                                           ');
   gotoxy(2,10);write('  Dateiname:                                                               ');
   gotoxy(2,11);write('                                                                           ');
   gotoxy(2,12);write('                                                                           ');
   gotoxy(2,13);write('  Abbruch mit [ESC]                                                        ');
   gotoxy(2,14);write('ͼ');

   { Eingabe des Dateinamens, bei Abbruch - Meldung }
   gotoxy (16,10);
   IF readDateiName (dateiname) = false THEN BEGIN
      gotoxy(17,19);write('ͻ');
      gotoxy(17,20);write('         Es wurde keine Datei geffnet!         ');
      gotoxy(17,21);write('ͼ');
      wait;
      exit;
   END;

   { Versucht die angegebene Datei zu ffnen }
   {$I-}
   assign (eindat, dateiname);
   reset (eindat);
   IF ioresult<>0 THEN BEGIN
      gotoxy(17,19);write('ͻ');
      gotoxy(17,20);write('         Fehler beim ffnen der Datei !         ');
      gotoxy(17,21);write('ͼ');
      wait;
      exit;
   END; {$I+}

   { DataPtr neu initialisieren. }
   data  := new (AdjPtr, init);
   error := FALSE;

   { Datei auswerten. }
   WHILE NOT eof (eindat) AND NOT error DO BEGIN
      readln (eindat, s);

      { Kurzbezeichnung auswerten. }
      tokenize (s, tok, ' ');
      IF (length (tok) > 0) AND (length (tok) <= 4) THEN BEGIN
         strtoupper (tok);
         bez := tok;
         IF NOT strisAlphaNum (bez) THEN
            error := TRUE;
      END ELSE
         error := TRUE;


      { Namen auswerten. }
      tokenize ('', tok, '');
      IF (length (tok) > 0) AND (length (tok) <= 20) THEN BEGIN
         name := tok;
         IF NOT strisAlphaNum (name) THEN
            error := TRUE;
      END ELSE
         error := TRUE;


      { Minimale Dauer einlesen. }
      tokenize ('', tok, ' ');
      IF (length (tok) > 0) AND (length (tok) <= 5) THEN BEGIN
         val (tok, min, c);

         IF c <> 0 THEN
            error := TRUE;
      END ELSE
         error := TRUE;


      { Maximale Dauer einlesen. }
      tokenize ('', tok, ' ');
      IF (length (tok) > 0) AND (length (tok) <= 5) THEN BEGIN
         val (tok, max, c);

         IF c <> 0 THEN
            error := TRUE;
      END ELSE
         error := TRUE;

      { Wenn kein Fehler aufgetreten ist, Knoten erstellen. }
      IF NOT error THEN
         ok := data^.add_Knoten (bez, name, min, max);


      { Abhngigkeiten falls vorhanden auswerten. }
      tokenize ('', tok, ' ');
      WHILE (length (tok) > 0) AND NOT error DO BEGIN
         { Abhngigkeit eintragen, wenn Fehler, Abbruch. }
         IF NOT data^.add_Link (tok, bez) THEN
            error := TRUE;
         tokenize ('', tok, ' ');
      END;
   END;

   IF NOT error THEN BEGIN
      { Erfolgsmeldung. }
      gotoxy(17,19);write('ͻ');
      gotoxy(17,20);write('          Datei erfolgreich geffnet !          ');
      gotoxy(17,21);write('ͼ');
      close (eindat);
      wait;

   END ELSE BEGIN
      { Fehlermeldung. }
      dispose (data, done);
      data := new (AdjPtr, init);

      gotoxy(17,19);write('ͻ');
      gotoxy(17,20);write('         Es ist ein Fehler aufgetreten !        ');
      gotoxy(17,21);write('ͼ');
      close (eindat);
      wait;
   END;
END;



{ Procedure Linearisieren.
  Linearisiert wahlweise den gesamten Graphen oder eine Arbeitsvorgang. }
PROCEDURE Scheduler.Graph_Linearisieren;

VAR
   h       : ListePtr;
   s       : string;
   k       : string4;
   jn      : char;
   min, max: integer;
   ok      : boolean;

BEGIN
   IF data^.isEmpty THEN BEGIN
      clrscr;
      writeln (''); writeln ('');
      writeln (ERR01);
      wait;
   END ELSE

   REPEAT
      min := 0;
      max := 0;

      { Das Men ausgeben. }
      clrscr;
      gotoxy(22,7); write('ͻ');
      gotoxy(22,8); write('  1..gesamten Graph linearisieren   ');
      gotoxy(22,9); write('  2..fr eine Arbeitsvorgang lin.   ');
      gotoxy(22,10);write('  0..Zurck                         ');
      gotoxy(22,11);write('ͼ');

      { Abfrage der Tastatur. }
      REPEAT
         jn:='9';
         jn := ricky;
      UNTIL (jn<='2') AND (jn>='0');

      { Begin der Auswertung. }
      CASE jn OF

         { Gesamten Graph linearisieren. }
         '1': BEGIN
                 h := NIL;
                 ok := data^.linearisieren ('', h, min, max);
                 data^.reset_Besucht;
                 Knoten_Ausgeben (TITLE02, h, min, max);
              END;

         { einen Arbeitsvorgang linearisieren. }
         '2': BEGIN
                 clrscr;
                 writeln ('Welcher Arbeitsvorgang soll linearisiert werden?');

                 { Kurzbez. einlesen. }
                 write ('Kurzbezeichnung: ');
                 readstrn (s, 4);
                 strtoupper (s);
                 k := s;

                 { berprfung, ob dieser Arbeitsvorgang existiert. }
                 IF data^.find (k) = NIL THEN BEGIN
                    writeln (''); writeln ('');
                    writeln (ERR02);
                    wait;
                    exit;

                 { Linearisieren. }
                 END ELSE BEGIN
                    h := NIL;
                    ok := data^.linearisieren (k, h, min, max);
                    data^.reset_Besucht;
                    Knoten_Ausgeben (TITLE02, h, min, max);
                 END;
              END;
      END;
   UNTIL jn='0';
END;




{ Prozedure Graph_Speichern.
  Speichert den Graph in ein angegebenen File. }
PROCEDURE Scheduler.Graph_Speichern;

VAR
   ausdat   : text;
   i,j      : integer;
   dateiname: string13;
   l        : ListePtr;
   k, t     : AdjKnotenPtr;
   ok       : boolean;

BEGIN
   clrscr;
   IF data^.isEmpty THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR01);
      wait;
      exit;
   END;
   gotoxy(2,8); write('ͻ');
   gotoxy(2,9); write('                                                                           ');
   gotoxy(2,10);write('  Dateiname:                                                               ');
   gotoxy(2,11);write('                                                                           ');
   gotoxy(2,12);write('                                                                           ');
   gotoxy(2,13);write('  Abbruch mit [ESC]                                                        ');
   gotoxy(2,14);write('ͼ');

   { Eingabe des Dateinamens }
   gotoxy (16,10);
   IF readDateiName (dateiname) = false THEN BEGIN

      { Bei fehlerhafter Eingabe - Abbruch. }
      gotoxy(17,19);write('ͻ');
      gotoxy(17,20);write('         Es wurde keine Datei geffnet!         ');
      gotoxy(17,21);write('ͼ');
      wait;
      exit;
   END;

   { Versucht die angegebene Datei zu ffnen + berprfung
     ob Datei schon existiert. }
   {$I-}
   assign (ausdat, dateiname);
   reset (ausdat);
   IF ioresult = 0 THEN

      { Abfrage ob Datei berschreiben }
      IF NOT jn_abfrage (ABFRAGE02) THEN BEGIN
         close (ausdat);
         exit;
      END;

   rewrite (ausdat);
   {$I-}

   { Graph linearisieren. }
   ok := data^.linearisieren ('', l, i, j);
   data^.reset_Besucht;

   { Arbeitsvorgnge einzeln speichern. }
   l^.gotoStart;
   WHILE l^.eol = FALSE DO BEGIN
      k := l^.getData;
      write (ausdat, k^.kurzbez, ' ', k^.name, ' ', k^.min, ' ', k^.max);

      { Abhngigkeiten speichern. }
      IF NOT k^.partOf^.isEmpty THEN BEGIN
         k^.partOf^.gotoStart;

         { Abhngigkeiten durcharbeiten. }
         WHILE NOT k^.partOf^.eol DO BEGIN
            t := k^.partOf^.getdata;
            write (ausdat, ' ', t^.kurzbez);
            k^.partOf^.gotoNext;
         END;
      END;

      writeln (ausdat, '');
      l^.gotonext;
   END;

   { Erfolgsausgabe. }
   gotoxy(17,19);write('ͻ');
   gotoxy(17,20);write('          Datei erfolgreich gesichert!          ');
   gotoxy(17,21);write('ͼ');
   close (ausdat);
   wait;
end;



{ Prozedur Kante_Ausgeben.
  Gibt die Abhngigkeiten eines gewnschten Knotens aus. }
PROCEDURE Scheduler.Kante_Ausgeben;

VAR
   s : string;
   k : string4;
   h, t : AdjKnotenPtr;

BEGIN
   clrscr;

   { berprfung ob berhaupt Daten vorhanden.}
   IF data^.isEmpty THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR01);
      wait;
      exit;
   END;

   writeln ('Fr welchen Arbeitsvorgang sollen die Abhngigkeiten ausgegeben werden?');

   { Kurzbez. einlesen. }
   write   ('Kurzbezeichnung: ');
   readstrn (s, 4);
   strtoupper (s);
   k := s;

   { berprfung ob Arbeitsvorgang existiert. }
   h := data^.find (k);
   IF h = NIL THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR02);
      wait;
      exit;
   END;

   writeln (''); writeln ('');

   { bergeordnete Arbeitsvorgnge ausgeben. }
   IF h^.partOf^.isEmpty THEN
      write (k, ' ist ein Zielknoten.')
   ELSE BEGIN
      h^.partOf^.gotoStart;
      write (k, ' voraussetzend fr: ');

      { Abhngigkeiten durcharbeiten. }
      WHILE NOT h^.partOf^.eol DO BEGIN
         t := h^.partOf^.getdata;
         write (t^.kurzbez, ' ');
         h^.partOf^.gotoNext;
      END;
   END;

   writeln ('');

   { Untergeordnete Arbeitsvorgnge ausgeben. }
   IF h^.Parts^.isEmpty THEN
      write (k, ' ist ein Startknoten.')
   ELSE BEGIN
      h^.Parts^.gotoStart;
      write (k, ' setzt Voraus:      ');

      { Abhngigkeiten durcharbeiten. }
      WHILE NOT h^.Parts^.eol DO BEGIN
         t := h^.Parts^.getdata;
         write (t^.kurzbez, ' ');
         h^.Parts^.gotoNext;
      END;
   END;

   wait;
END;




{ Prozedur Kante_Lschen.
  Entfernt eine Abhngigkeit zwischen zwei Arbeitsvorgngen. }
PROCEDURE Scheduler.Kante_Loeschen;

VAR
   s : string;
   k1, k2 : string4;

BEGIN
   clrscr;

   { berprfung ob berhaupt Arbeitsvorgnge vorhanden sind.}
   IF data^.isEmpty THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR01);
      wait;
      exit;
   END;

   writeln ('Welche Abhngigkeit soll gelscht werden?');

   { 1. Kurzbez. einlesen. }
   write   ('Von Arbeitsvorgang (Kurzbez.): ');
   readstrn (s, 4);
   strtoupper (s);
   k1 := s;

   { 2. Kurzbez. einlesen. }
   writeln ('');
   write   ('zu Arbeitsvorgang (Kurzbez.):  ');
   readstrn (s, 4);
   strtoupper (s);
   k2 := s;

   { berprfung ob Arbeitsvorgnge existierten. }
   IF (data^.find (k1) = NIL) OR (data^.find (k2) = NIL) THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR02);
      wait;
      exit;
   END;

   { Abhngigkeit zwischen den Arbeitsvorgngen lschen. }
   IF NOT data^.remove_Link (k1, k2) THEN BEGIN
      writeln (''); writeln ('');
      writeln ('Fehler beim entfernen (berprfen Sie die Eingabereihenfolge)!');
      wait;
   END;
END;




{ Prozedur Kante_Neu.
  Erzeugt eine neue Abhngigkeit zwischen zwei Arbeitsvorgngen. }
PROCEDURE Scheduler.Kante_Neu;

VAR
   s : string;
   k1, k2 : string4;

BEGIN
   clrscr;

   { berprfung ob berhaupt Arbeitsvorgnge vorhanden sind. }
   IF data^.isEmpty THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR01);
      wait;
      exit;
   END;

   writeln ('Welche Abhngigkeit soll verknpft werden?');

   { 1. Kurzbez. einlesen. }
   write   ('Von Arbeitsvorgang (Kurzbez.): ');
   readstrn (s, 4);
   strtoupper (s);
   k1 := s;

   { berprfung ob Arbeitsvorgang existiert. }
   IF data^.find (k1) = NIL THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR02);
      wait;
      exit;
   END;

   { 2. Kurzbez. einlesen. }
   writeln ('');
   write   ('zu Arbeitsvorgang (Kurzbez.):  ');
   readstrn (s, 4);
   strtoupper (s);
   k2 := s;

   { berprfung ob Arbeitsvorgang existiert. }
   IF data^.find (k2) = NIL THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR02);
      wait;
      exit;
   END;

   { Abhngigkeit zwischen den Arbeitsvorgngen erstellen. }
   IF NOT data^.add_Link (k1, k2) THEN BEGIN
      writeln (''); writeln ('');
      writeln ('Fehler: Die Abhngigkeit konnte nicht eingefgt werden (Rekursion?)!');
      wait;
   END;
END;




{ Prozedur Knoten_Ausgeben.
  Gibt bergebenen Knoten am Bilschirm aus. }
PROCEDURE Scheduler.Knoten_Ausgeben (s: string; l : ListePtr;
                                    min, max: integer);

VAR
   k    : AdjKnotenPtr;

BEGIN
   clrscr;

   { berprfung ob berhaupt Knoten vorhanden. }
   IF l^.isEmpty THEN
      writeln ('Keine Arbeitsvorgnge eingegeben')

   { Alle Knoten ausgeben. }
   ELSE BEGIN
      writeln (s);
      writeln ('');

      l^.gotoStart;
      writeln (HEADER01);

      { Arbeitsvorgnge ausgeben. }
      WHILE l^.eol = FALSE DO BEGIN
         k := l^.getData;
         writeln (k^.kurzbez:15, ' | ', k^.name:20, ' | ', k^.min:5, ' ', k^.max:5);

         l^.gotonext;

         { Wenn Bildschirmende erreicht - Warten. }
         IF wherey > 23 THEN BEGIN
            wait;
            clrscr;
            writeln ('');
            IF l^.eol = FALSE THEN
               writeln (HEADER01);
         END;
      END;

      { Falls vorhanden die minimale Gesamtdauer ausgeben. }
      IF min > 0 THEN BEGIN
         writeln ('');
         writeln ('Die minimale Gesamtdauer betrgt ', min, ' Tage.');
      END;

      { Falls vorhanden die maximale Gesamtdauer ausgeben. }
      IF max > 0 THEN BEGIN
         writeln ('');
         writeln ('Die maximale Gesamtdauer betrgt ', max, ' Tage.');
      END;
   END;
   wait;
END;




{ Prozedur Knoten_Loeschen.
  Lscht einen Arbeitsvorgang. }
PROCEDURE Scheduler.Knoten_Loeschen;

VAR
   s  : string;
   h  : AdjKnotenPtr;
   ok : boolean;

BEGIN
   clrscr;
   writeln ('Welcher Arbeitsvorgang soll gelscht werden?');
   write   ('Kurzbezeichnung: ');

   { Kurzbez. einlesen. }
   readstrn (s, 4);
   strtoupper (s);

   { Eintrag suchen. }
   h := data^.find (s);

   { Wenn Arbeitsvorgang nicht gefunden - Fehlermeldung. }
   IF h = NIL THEN BEGIN
      writeln (''); writeln ('');
      writeln ('Es konnte kein solcher Eintrag gefunden werden!');
      wait;

   END ELSE BEGIN
      { Abfrage ob wirklich lschen. }
      IF jn_abfrage (ABFRAGE01) THEN

         { Knoten entfernen. }
         ok := data^.remove_Knoten (s);
   END;
END;



{ Prozedur Knoten_Neu.
  Erzeugt einen neuen Knoten, wenn mglich. }
PROCEDURE Scheduler.Knoten_Neu;

VAR
   jn : char;
   ok : boolean;
   k  : string4;
   b  : string20;
   s  : string;
   min, max : integer;

BEGIN
   min := 0;
   max := 0;

   clrscr;
   writeln ('Fr die Erstellung eines Arbeitsvorganges werden folgende Daten bentigt:');

   { Kurzbez. einlesen. }
   write   ('Kurzbezeichnung: ');
   readstrn (s, 4);
   strtoupper (s);
   k := s;

   { Fehlerhafte Eingabe? Wenn ja, Abbruch }
   IF length (k) = 0 THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR03);
      wait;
      exit;
   END ELSE

   { berprfung ob Kurzbezeichnung schon existiert. }
   IF data^.find (k) <> NIL THEN BEGIN
      writeln (''); writeln ('');
      writeln ('Fehler: Ein Arbeitsvorgang mit dieser Kurzbezeichnung existiert bereits - ABBRUCH!!');
      wait;
      exit;
   END;

   { Namen einlesen. }
   writeln ('');
   write   ('Name:            ');
   readstrn (s, 20);
   b := s;

   { Fehlerhafte Eingabe? Wenn ja, Abbruch }
   IF length (b) = 0 THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR03);
      wait;
      exit;
   END;

   { Minimale Dauer einlesen. }
   writeln ('');
   write   ('Minimale Dauer:  ');
   min := readinteger;

   { Fehlerhafte Eingabe. }
   IF min = 0 THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR03);
      wait;
      exit;
   END;

   { Maximale Dauer einlesen. }
   writeln ('');
   write   ('Maximale Dauer:  ');
   max := readinteger;

   { Fehlerhafte Eingabe. }
   IF max = 0 THEN BEGIN
      writeln (''); writeln ('');
      writeln (ERR03);
      wait;
      exit;
   END;

   { berprfung ob min <= max Dauer ist. }
   IF min > max THEN BEGIN
      writeln (''); writeln ('');
      writeln ('Fehler: Minimale Dauer grsser als Maximale Dauer - ABBRUCH!!');
      wait;
      exit;
   END;

   { Neuen Arbeitsvorgang eintragen. }
   ok := data^.add_Knoten (k, b, min, max);

   { Wenn der Knoten nicht eingetragen werden konnte - Fehlermedlung. }
   IF NOT ok THEN BEGIN
      writeln (''); writeln ('');
      write ('Fehler beim Erstellen des Knotens');
      wait;
   END;
END;




{ Prozedur Menu_Abhaengigkeiten.
  Hier knnen Abhaengigkeiten erstellt, ausgegeben und geloescht werden. }
PROCEDURE Scheduler.Menu_Abhaengigkeiten;

VAR
   jn:  char;

BEGIN
   REPEAT

      { Das Men ausgeben. }
      clrscr;
      gotoxy(22,7); write('ͻ');
      gotoxy(22,8); write('  1..neue Abhngigkeit              ');
      gotoxy(22,9); write('  2..Abh. eines Knotens anzeigen    ');
      gotoxy(22,10);write('  3..Abhngigkeit lschen           ');
      gotoxy(22,11);write('  0..Zurck                         ');
      gotoxy(22,12);write('ͼ');

      { Abfrage der Tastatur. }
      REPEAT
         jn:='9';
         jn := ricky;
      UNTIL (jn<='3') AND (jn>='0');

      { Begin der Auswertung. }
      CASE jn OF
         '1':Kante_Neu;
         '2':Kante_Ausgeben;
         '3':Kante_Loeschen;
      END;
   UNTIL jn='0';
END;



{ Prozedur Menu_Arbeitsvorgaenge.
  Hier knnen Arbeitsvorgaenge erstellt, ausgegeben und geloescht werden. }
PROCEDURE Scheduler.Menu_Arbeitsvorgaenge;

VAR
   jn:  char;

BEGIN
   REPEAT

      { Das Men ausgeben. }
      clrscr;
      gotoxy(22,7); write('ͻ');
      gotoxy(22,8); write('  1..neuer Arbeitsvorgang           ');
      gotoxy(22,9); write('  2..Arbeitsvorgnge auflisten      ');
      gotoxy(22,10);write('  3..Arbeitsvorgang lschen         ');
      gotoxy(22,11);write('  0..Zurck                         ');
      gotoxy(22,12);write('ͼ');

      { Abfrage der Tastatur. }
      REPEAT
         jn:='9';
         jn := ricky;
      UNTIL (jn<='3') AND (jn>='0');

      { Begin der Auswertung. }
      CASE jn OF
         '1':Knoten_Neu;
         '2':Knoten_Ausgeben (TITLE01, data^.get_alle_Knoten, 0, 0);
         '3':Knoten_Loeschen;
      END;
   UNTIL jn='0';
END;



{ Prozedur Menu_Main.
  Gibt die Auswahlmglichkeiten am Bildschirm aus und wartet auf eine
  Benutzereingabe. Diese wird dann ausgefhrt. }
PROCEDURE Scheduler.Menu_Main;

VAR
   jn:  char;
   max: integer;
   h: ListePtr;

BEGIN
   REPEAT

      { Das Hauptmen ausgeben. }
      clrscr;
      gotoxy(22,7); write('ͻ');
      gotoxy(22,8); write('  1..Arbeitsvorgnge bearbeiten     ');
      gotoxy(22,9); write('  2..Abhngigkeiten bearbeiten      ');
      gotoxy(22,10);write('  3..Startknoten auflisten          ');
      gotoxy(22,11);write('  4..Zielknoten auflisten           ');
      gotoxy(22,12);write('  5..Linearisieren                  ');
      gotoxy(22,13);write('  6..Kritischen Pfad berechnen      ');
      gotoxy(22,14);write('  7..Daten laden                    ');
      gotoxy(22,15);write('  8..Daten sichern                  ');
      gotoxy(22,16);write('  0..Programm beenden               ');
      gotoxy(22,17);write('ͼ');

      { Abfrage der Tastatur. }
      REPEAT
         jn:='9';
         jn := ricky;
      UNTIL (jn<='8') AND (jn>='0');

      { Begin der Auswertung. }
      CASE jn OF
         '1':Menu_Arbeitsvorgaenge;
         '2':Menu_Abhaengigkeiten;
         '3':Knoten_Ausgeben (TITLE04, data^.start_Knoten, 0, 0);
         '4':Knoten_Ausgeben (TITLE05, data^.ziel_Knoten, 0, 0);
         '5':Graph_Linearisieren;
         '6': BEGIN
                 max := 0;
                 h := NIL;
                 data^.kritischer_Pfad ('', max, h);
                 Knoten_Ausgeben (TITLE03, h, 0, max);
              END;
         '7':Graph_laden;
         '8':Graph_speichern;
      END;
   UNTIL jn='0';
END;



{ Hauptprogramm. }
BEGIN
   sched := new (schedPtr, init);
   dispose (sched, done);
END.
